-- Makes buying and selling for profitmuch easier.
-- By SvK  http://svk.mondrary.com svk105@msn.com

local TheOriginal_AuctionFrameBrowse_Update;
local TheOriginal_AuctionSellItemButton_OnEvent;
local TheOriginal_AuctionFrameTab_OnClick;
local TheOriginal_InboxFrame_Update;
local TheOriginal_InboxFrame_OnClick;

function Ahplus_Initialize()

	RegisterForSave("AhplusBuyoutFactor");
--	Only automatically bid on auctions that are cheaper than PriceDB price * AhplusBuyoutFactor

	RegisterForSave("AhplusBuyoutOnClick");
--	Buy out auction (if buyout < PriceDB price) when I click on it

	RegisterForSave("AhplusBidOnClick");
--	Bid on auction (if bid < PriceDB price) when I click on it

	RegisterForSave("AhplusBidOnSight");
--	Bid on auction (if bid < PriceDB price * AhplusBuyoutFactor) when auction appears in window

	RegisterForSave("AhplusBuyoutOnSight");
--	Buy out auction (if buyout < PriceDB price * AhplusBuyoutFactor) when auction appears in window

	RegisterForSave("AhplusTakeBidsFromMail");
--	Remove money from AH from inbox as soon as they appear in the window

	RegisterForSave("AhplusTakeItemsFromMail");
--	Remove items from AH from inbox as soon as they appear in the window

	RegisterForSave("AhplusAuctionNow");
--	Begin auction as soon as I place item in Auction window

	RegisterForSave("AhplusCounterBid");
--	Bid on outbid auction (if bid < PriceDB price) when outbid

	RegisterForSave("AhplusDestroyMarket");
--	Create auction:  1s min bid, no buyout, 1 day duration

	RegisterForSave("AhplusShowPricePerItem");
--	Divide prices by number of items in stack

	RegisterForSave("AhplusInitialBidMultiplier");
--	Auction initial price = PriceDB price * count * AhplusInitialBidMultiplier

	if ( not AhplusBuyoutFactor ) then
		AhplusBuyoutFactor = 0.8;
	end
	if ( not AhplusInitialBidMultiplier ) then
		AhplusInitialBidMultiplier = 0.5;
	end


-- register for events
	this:RegisterEvent("NEW_AUCTION_UPDATE");
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("AUCTION_HOUSE_SHOW");
	this:RegisterEvent("AUCTION_HOUSE_CLOSED");
	this:RegisterEvent("MAIL_SHOW");
	this:RegisterEvent("MAIL_CLOSED");
	this:RegisterEvent("CHAT_MSG_SYSTEM");

-- hook functions
	TheOriginal_AuctionFrameBrowse_Update = AuctionFrameBrowse_Update;
	AuctionFrameBrowse_Update = Ahplus_AuctionFrameBrowse_Update;

	TheOriginal_AuctionSellItemButton_OnEvent = AuctionSellItemButton_OnEvent;
	AuctionSellItemButton_OnEvent = Ahplus_AuctionSellItemButton_OnEvent;

	TheOriginal_AuctionFrameTab_OnClick = AuctionFrameTab_OnClick;
	AuctionFrameTab_OnClick = Ahplus_AuctionFrameTab_OnClick;

	TheOriginal_InboxFrame_Update = InboxFrame_Update;
	InboxFrame_Update = Ahplus_InboxFrame_Update;

	TheOriginal_InboxFrame_OnClick = InboxFrame_OnClick;
	InboxFrame_OnClick = Ahplus_InboxFrame_OnClick;

-- slash commands
	SlashCmdList["SELLALLSLASH"] = function(msg)
		Ahplus_SellAll(msg);
	end;
	SLASH_SELLALLSLASH1 = "/sellall";

	SlashCmdList["BIDSLASH"] = function(msg)
		Ahplus_BidOnPage();
	end;
	SLASH_BIDSLASH1 = "/bid";

-- initialize moneyframes to zero
	MoneyFrame_Update( "AhplusMoneyCheapItems", 0 );
	MoneyFrame_Update( "AhplusMoneyResalePrice", 0 );
	MoneyFrame_Update( "AhplusMoneyInventoryPrice", 0 );
	MoneyFrame_Update( "AhplusMoneyAvgBuyout", 0 );
	MoneyFrame_Update( "AhplusMoneyLowBuyout", 0 );
	MoneyFrame_Update( "AhplusMoneyAvgPrice", 0 );
	MoneyFrame_Update( "AhplusMoneyHighBid", 0 );
	Ahplus_SetDisplayPrice(0 );

end

function Ahplus_AuctionFrameBrowse_Update()
	local numBatchAuctions, totalAuctions = GetNumAuctionItems("list");
	local name, texture, count, quality, canUse, minBid, minIncrement, buyoutPrice, duration, bidAmount, highBidder, owner;
	local goodPrice, gotOne;

	local numPages = ceil( totalAuctions / 50 );
	TheOriginal_AuctionFrameBrowse_Update();

	local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame);
	gotOne = 0;

	for i=1,NUM_BROWSE_TO_DISPLAY do
		goodPrice = 0;
		index = offset + i;
		if ( index > (numBatchAuctions + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page)) ) then
		else
			buttonName = "BrowseButton"..i;
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", index);
			iconTexture = getglobal(buttonName.."ItemIconTexture");
			if( PriceDatabase_GetPrice(name) ~= nil ) then
				if ( owner ~= UnitName("player") ) then
					if ( not highBidder ) then
						if( bidAmount > 0 ) then
							if( bidAmount + minIncrement < PriceDatabase_GetPrice(name) * count) then
								if( bidAmount + minIncrement < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor) then
									iconTexture:SetVertexColor(0.5, 1.0, 0.5);
									goodPrice = 1; -- Will bid on this automatically
								else
									iconTexture:SetVertexColor(1.0, 1.0, 0.5);
									goodPrice = 0.5;  -- will bid only on click
								end
							end
						else
							if( minBid < PriceDatabase_GetPrice(name) * count) then
								if( minBid < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor) then
									iconTexture:SetVertexColor(0.5, 1.0, 0.5);
									goodPrice = 1;  -- Will bid on this automatically
								else
									iconTexture:SetVertexColor(1.0, 1.0, 0.5);
									goodPrice = 0.5;  -- will bid only on click
								end
							end
						end
						if( buyoutPrice > 0 ) then
							if( buyoutPrice < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor ) then
								goodPrice = 2;
								iconTexture:SetVertexColor(0.1, 1.0, 0.1);
							end
						end
					end
				end
			end
			if( bidAmount == 0 ) then
-- Sometimes "owner" is nil, and concatenating a nil value produces an ugly error message.  :(
				if( owner ) then
					getglobal(buttonName.."HighBidder"):SetText(RED_FONT_COLOR_CODE..NO_BIDS..FONT_COLOR_CODE_CLOSE.." "..owner);
				else
					getglobal(buttonName.."HighBidder"):SetText(RED_FONT_COLOR_CODE..NO_BIDS..FONT_COLOR_CODE_CLOSE);
				end
			end
-- Option to display price per item.
			if ( AhplusShowPricePerItem ) then
				local moneyFrame = getglobal(buttonName.."MoneyFrame");
				buyoutMoneyFrame = getglobal(buttonName.."BuyoutMoneyFrame");
				-- If not bidAmount set the bid amount to the min bid
				if ( bidAmount == 0 ) then
					MoneyFrame_Update(moneyFrame:GetName(), floor(0.5 + minBid / count) );
				else
					MoneyFrame_Update(moneyFrame:GetName(), floor(0.5 + bidAmount / count) );
				end
				if ( buyoutPrice > 0 ) then
					MoneyFrame_Update(buyoutMoneyFrame:GetName(), floor(0.5 + buyoutPrice / count) );
				end
			end
-- This is the item the user clicked on.  Buy out or bid if appropriate.
			if ( GetSelectedAuctionItem("list") and (offset + i) == GetSelectedAuctionItem("list") ) then
				if ( not highBidder and GetMoney() >= MoneyInputFrame_GetCopper(BrowseBidPrice) ) then
					BrowseBidButton:Enable();
					if ( goodPrice == 2 ) then
						if ( AhplusBuyoutOnClick == 1 ) then
							PlaceAuctionBid("list", GetSelectedAuctionItem("list"), buyoutPrice);
						else
							goodPrice = 1;
						end
					else 
						if ( ( goodPrice == 1 or goodPrice == 0.5 ) and AhplusBidOnClick == 1) then
							if ( bidAmount > 0 ) then
								bidAmount = bidAmount + minIncrement;
							else
								bidAmount = minBid;
							end
							PlaceAuctionBid("list", GetSelectedAuctionItem("list"), bidAmount);
							BrowseBidButton:Disable();
						end
					end
				end
			end
		end
	end

	-- automatically bid and buy out ON SIGHT here
	if ( AhplusBidOnSight == 1 or AhplusBuyoutOnSight == 1 ) then
		for i=NUM_AUCTION_ITEMS_PER_PAGE, 1, -1 do
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", i);
			if( PriceDatabase_GetPrice(name) ~= nil ) then
				if ( owner ~= UnitName("player") ) then
					if ( not highBidder ) then
						if( buyoutPrice > 0 ) then
							if( AhplusBuyoutOnSight == 1 and buyoutPrice < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor ) then
								PlaceAuctionBid("list", i, buyoutPrice);
								Ahplus_Print("Buying "..count.." "..name.." for "..buyoutPrice);
								i = -10;
							end
						end
						if( bidAmount > 0 ) then
							if ( AhplusBidOnSight == 1 and bidAmount + minIncrement < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor ) then
								PlaceAuctionBid("list", i, bidAmount + minIncrement);
								Ahplus_Print("Bidding "..bidAmount + minIncrement.." on "..count.." "..name);
								i = -10;
							end
						else
							if ( AhplusBidOnSight == 1 and ( minBid < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor ) ) then
								PlaceAuctionBid("list", i, minBid);
								Ahplus_Print("Bidding "..minBid.." on "..count.." "..name);
								i = -10;
							end
						end
					end
				end
			end
			if ( i == 1 and AhplusBidOnPage ) then
				AhplusBidOnPage = nil;
				AhplusBidOnSight = 0;
				AhplusBuyoutOnSight = 0;				
				AhplusTextBigMessage:Hide();
				Ahplus_QueryEnds();
				-- Switch to next page if there is one
				if ( numPages < AuctionFrameBrowse.page + 1 ) then
					AuctionFrameBrowse.page = AuctionFrameBrowse.page + 1; 
					BrowseScrollFrameScrollBar:SetValue(0); 
					AuctionFrameBrowse_Search(AuctionFrameBrowse.page);
				end
			end
		end
	end

	if ( not AhplusQueryInProgress and not CanSendAuctionQuery() ) then
		Ahplus_QueryBegins();
	end
end

function Ahplus_AnalyzePage()
	AhplusAnalyzeBrowse = 0;
	local lowBuyout = nil;
	local highBid = 0;
	local AhplusNumBids = 0;
	local AhplusBidsTotal = 0;
	local AhplusMinBidsTotal = 0;
	local AhplusBuyoutsTotal = 0;
	local AhplusNumItems = 0;
	local AhplusNumItemsWithBuyout = 0;
	local AhplusNumCheapItems = 0;
	local AhplusNumCheapBuyoutItems = 0;
	local AhplusCostCheapItems = 0;
	local AhplusCostCheapBuyoutItems = 0;
	local numBatchAuctions, totalAuctions = GetNumAuctionItems("list");
	local numPages = ceil( totalAuctions / 50 );
	local itemName = strlower( BrowseName:GetText() );

		for i=1, numBatchAuctions do
			local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", i);				
			if ( itemName == strlower ( name ) ) then
			if ( owner ~= UnitName("player") and not highBidder ) then
				AhplusNumBids = AhplusNumBids + 1;
				AhplusBidsTotal = AhplusBidsTotal + bidAmount;
				AhplusNumItems = AhplusNumItems + count;
				if ( bidAmount / count > highBid ) then
					highBid = bidAmount / count;
				end
				
				if ( bidAmount > 0 ) then
					AhplusMinBidsTotal = AhplusMinBidsTotal + bidAmount;
					if ( PriceDatabase_GetPrice(name) and bidAmount + minIncrement < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor and not highBidder) then
						AhplusNumCheapItems = AhplusNumCheapItems + count;
						AhplusCostCheapItems = AhplusCostCheapItems + bidAmount + minIncrement;
					end
				else
					AhplusMinBidsTotal = AhplusMinBidsTotal + minBid;
					if ( PriceDatabase_GetPrice(name) and minBid < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor and not highBidder ) then
						AhplusNumCheapItems = AhplusNumCheapItems + count;
						AhplusCostCheapItems = AhplusCostCheapItems + minBid;
					end
				end
					if ( buyoutPrice > 0 ) then
					AhplusBuyoutsTotal = AhplusBuyoutsTotal + buyoutPrice;
					AhplusNumItemsWithBuyout = AhplusNumItemsWithBuyout + count;
					if ( not highBidder ) then
						if ( lowBuyout ) then
							if ( buyoutPrice / count < lowBuyout ) then
								lowBuyout = buyoutPrice / count;
							end
						else
							lowBuyout = buyoutPrice / count;
						end
					end
						if ( PriceDatabase_GetPrice(name)  and buyoutPrice < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor  and not highBidder) then
						AhplusNumCheapBuyoutItems = AhplusNumCheapBuyoutItems + count;
						AhplusCostCheapBuyoutItems = AhplusCostCheapBuyoutItems + buyoutPrice;
					end
				end
			end
			end
		end	


	Ahplus_TabSpecificText(1);

	if ( AhplusNumItems > 0 ) then	
-- AhplusChatFrame deleted!
--		AhplusChatFrame:AddMessage( itemName .. "x " .. AhplusNumItems .. " .  " .. AhplusNumBids .. " auctions.");
--		AhplusChatFrame:AddMessage( "True bids:  " .. Ahplus_MoneyPrint( AhplusBidsTotal ) );
--		AhplusChatFrame:AddMessage( "All bids:  " .. Ahplus_MoneyPrint( AhplusMinBidsTotal ) );
--		AhplusChatFrame:AddMessage( "All buyouts:  " .. Ahplus_MoneyPrint( AhplusBuyoutsTotal ) );
--		AhplusChatFrame:AddMessage( "Average buyout: " .. Ahplus_MoneyPrint(AhplusBuyoutsTotal / AhplusNumItemsWithBuyout) );
--		AhplusChatFrame:AddMessage( "Lowest buyout: " .. Ahplus_MoneyPrint(lowBuyout) );
--		AhplusChatFrame:AddMessage( "Average price: " .. Ahplus_MoneyPrint(AhplusMinBidsTotal / AhplusNumItems) );
--		AhplusChatFrame:AddMessage( "Highest bid: " .. Ahplus_MoneyPrint(highBid) );

		AhplusTextNumAuctions:SetText(AhplusNumItems .. " Pieces.  " .. AhplusNumBids .. " Auctions.");
		MoneyFrame_Update( "AhplusMoneyAvgBuyout", floor(AhplusBuyoutsTotal / AhplusNumItemsWithBuyout + 0.5));
		if (lowBuyout ) then
			MoneyFrame_Update( "AhplusMoneyLowBuyout", floor(lowBuyout + 0.5));	
		else
			MoneyFrame_Update( "AhplusMoneyLowBuyout", 0);	
		end
		MoneyFrame_Update( "AhplusMoneyAvgPrice", floor(AhplusMinBidsTotal / AhplusNumItems + 0.5));
		MoneyFrame_Update( "AhplusMoneyHighBid", floor(highBid + 0.5));

		if ( PriceDatabase_GetPrice(itemName) ) then
--			AhplusChatFrame:AddMessage( "Your price: " .. Ahplus_MoneyPrint( PriceDatabase_GetPrice(itemName) ) );
-- BUG??		Ahplus_SetDisplayPrice(PriceDatabase_GetPrice(itemName) );
			MoneyFrame_Update( "AhplusMoneyResalePrice",  AhplusNumCheapItems * PriceDatabase_GetPrice(itemName) );
		end
		MoneyFrame_Update( "AhplusMoneyCheapItems", AhplusCostCheapItems );
		if ( AhplusCostCheapItems > 0 ) then
			AhplusBidButton:Enable();
		else
			AhplusBidButton:Disable();
		end

		AhplusTextNumAuctions:SetText(AhplusNumItems .. " Pieces.  " ..  AhplusNumBids .. " Auctions.");
	else
		MoneyFrame_Update( "AhplusMoneyLowBuyout", 0);	
		MoneyFrame_Update( "AhplusMoneyAvgBuyout", 0);
		MoneyFrame_Update( "AhplusMoneyAvgPrice", 0);
		MoneyFrame_Update( "AhplusMoneyHighBid", 0);
	end

end

function Ahplus_AuctionSellItemButton_OnEvent()
	local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo();

	TheOriginal_AuctionSellItemButton_OnEvent();

	Ahplus_SetAuctionPrice();

	if ( name and strlen ( name ) > 0 ) then
		local beginning, ending = strfind(name, " of the [Owl|Falcon|Eagle]");
-- Remove "of the whatever" from the item name
		if ( beginning ) then
			name = strsub(name, 1, beginning);
		end
		BrowseName:SetText( name );
		QueryAuctionItems(name, 0, 60, nil, nil, nil, AuctionFrameBrowse.page, IsUsableCheckButton:GetChecked(), quality);

		Ahplus_UpdateMiniFrame( name );
		Ahplus_ClearAnalysis();
	end

	if ( AhplusAuctionNow ) then
		if ( not AuctionFrameAuctions.page ) then
			AuctionFrameAuctions.page = 0;
		end
		if ( AhplusDestroyMarket == 1 ) then
			StartAuction(1, 0, 10080);
		else
			StartAuction(MoneyInputFrame_GetCopper(StartPrice), MoneyInputFrame_GetCopper(BuyoutPrice), AuctionFrameAuctions.duration);
		end
	end
end

function Ahplus_AuctionFrameTab_OnClick(index)

	local offset, index, value;
	local numBatchAuctions, totalAuctions;
	local numPages;
	local AhplusNumBids = 0;
	local AhplusBidsTotal = 0;
	local AhplusMinBidsTotal = 0;
	local AhplusBuyoutsTotal = 0;
	local AhplusNumItems = 0;
	local AhplusOutBid = 0;
	local AhplusBidQuality = nil;
	AhplusBidQuality = {};

	if ( not index ) then
		index = this:GetID();
	end

	if ( not index or index < 1 or index > 3 ) then
		index = 1;
	end

	TheOriginal_AuctionFrameTab_OnClick(index);

	Ahplus_TabSpecificText(index);

	
	if ( index == 1 ) then
		local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo();
		if ( name and strlen(name) > 0 ) then
			itemName = name;
		else
			itemName = BrowseName:GetText();
		end

		Ahplus_UpdateMiniFrame( itemName );
		Ahplus_AnalyzePage();

	elseif ( index == 2 ) then
		numBatchAuctions, totalAuctions = GetNumAuctionItems("bidder");
		numPages = ceil( totalAuctions / 50 );
		for j = 1, numPages do
			GetBidderAuctionItems(j);
			for i=1, numBatchAuctions do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("bidder", i);	
				if ( i + ( j - 1 ) * 50 <= totalAuctions ) then
					if ( highBidder ) then
						AhplusNumBids = AhplusNumBids + 1;
						AhplusBidsTotal = AhplusBidsTotal + bidAmount;
						AhplusNumItems = AhplusNumItems + count;
						if ( not AhplusBidQuality[quality] ) then
							AhplusBidQuality[quality] = count;
						else
							AhplusBidQuality[quality] = AhplusBidQuality[quality] + count;
						end
						if ( PriceDatabase_GetPrice(name) ) then
							AhplusBuyoutsTotal = AhplusBuyoutsTotal + PriceDatabase_GetPrice(name) * count;
						end
					else
						if ( AhplusUpBidOnSight == 1 and PriceDatabase_GetPrice(name) ) then
							--AhplusChatFrame:AddMessage("Outbid on " .. count .. " " .. name .. " " .. AhplusMoneyPrint(bidAmount));
							if ( bidAmount + minIncrement < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor ) then
								PlaceAuctionBid("bidder", i, bidAmount + minIncrement);
								--AhplusChatFrame:AddMessage("Bidding "..bidAmount + minIncrement.." on "..count.." "..name);							
							else
								AhplusOutBid = AhplusOutBid + 1;
							end
						else
							AhplusOutBid = AhplusOutBid + 1;
						end
					end
				end
			end
		end
		AhplusTextNumAuctions:SetText(AhplusNumItems .. " Pieces.  " .. AhplusNumBids .. " Bids.");
		MoneyFrame_Update( "AhplusMoneyAvgBuyout", 0 );
		MoneyFrame_Update( "AhplusMoneyLowBuyout", AhplusBidsTotal);
		MoneyFrame_Update( "AhplusMoneyAvgPrice", AhplusBuyoutsTotal);
		MoneyFrame_Update( "AhplusMoneyHighBid", floor(AhplusBuyoutsTotal * 1000 /AhplusBidsTotal + 0.5) / 1000);

--		AhplusChatFrame:AddMessage( "Resale value: " .. Ahplus_MoneyPrint(AhplusBuyoutsTotal) .. "  Profit rating: " .. AhplusBuyoutsTotal/AhplusBidsTotal );
--		AhplusChatFrame:AddMessage( "Outbid on " .. AhplusOutBid .. " auctions.");
--		for index, value in AhplusBidQuality do
--			--AhplusChatFrame:AddMessage( value .. " items of quality " .. index );
--		end
		GetBidderAuctionItems(1)
	elseif ( index == 3 ) then
		-- Update price when switching back to "Sell" tab

		local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo();

		numBatchAuctions, totalAuctions = GetNumAuctionItems("owner");
		numPages = ceil( totalAuctions / 50 );
		for j = 1, numPages do
			GetOwnerAuctionItems(j);
			for i=1, numBatchAuctions do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("owner", i);	
				if ( i + ( j - 1 ) * 50 <= totalAuctions ) then
					if ( highBidder ) then
						AhplusBidsTotal = AhplusBidsTotal + bidAmount;
						AhplusMinBidsTotal = AhplusMinBidsTotal + bidAmount;
					else
						AhplusMinBidsTotal = AhplusMinBidsTotal + minBid;
					end

					if ( not AhplusBidQuality[quality] ) then
						AhplusBidQuality[quality] = count;
					else
						AhplusBidQuality[quality] = AhplusBidQuality[quality] + count;
					end

					AhplusNumBids = AhplusNumBids + 1;
					AhplusNumItems = AhplusNumItems + count;

					if ( buyoutPrice > 0 ) then
						AhplusBuyoutsTotal = AhplusBuyoutsTotal + buyoutPrice;
					end
				end
			end
		end
--		AhplusChatFrame:AddMessage( AhplusNumItems .. " Pieces." .. AhplusNumBids .. " Auctions." );
--		for index, value in AhplusBidQuality do
--			--AhplusChatFrame:AddMessage( value .. " items of quality " .. index );
--		end

		AhplusTextNumAuctions:SetText(AhplusNumItems .. " Pieces.  " .. AhplusNumBids .. " Auctions.");
		MoneyFrame_Update( "AhplusMoneyAvgBuyout", 0 );
		MoneyFrame_Update( "AhplusMoneyLowBuyout", AhplusBidsTotal );
		MoneyFrame_Update( "AhplusMoneyAvgPrice", AhplusMinBidsTotal );
		MoneyFrame_Update( "AhplusMoneyHighBid", AhplusBuyoutsTotal );

--		AhplusChatFrame:AddMessage( Ahplus_MoneyPrint( AhplusBidsTotal ) .. " guaranteed.");
--		AhplusChatFrame:AddMessage( Ahplus_MoneyPrint( AhplusMinBidsTotal ) .. " if all auctions sell.");
--		AhplusChatFrame:AddMessage( Ahplus_MoneyPrint( AhplusBuyoutsTotal ) .. " if all auctions are bought out.");
		GetOwnerAuctionItems(1);
		Ahplus_SetAuctionPrice();

	end
end

function Ahplus_MoneyPrint(amount)
	local c,s,g; 
	local moneyString = "";
-- exit immediately if "amount" is nil
	if ( not amount ) then
		return moneyString;
	end

-- round to nearest copper
	amount = floor(amount + 0.5);

	c = mod(amount, COPPER_PER_SILVER);
	amount = amount - c;
	amount = amount / COPPER_PER_SILVER;
	s = mod(amount, SILVER_PER_GOLD);
	amount = amount - s;
	amount = amount / SILVER_PER_GOLD;
	g = amount;

	if ( g > 0 ) then
		moneyString = moneyString..g.."g";
	end
	if ( s < 10 and g > 0 ) then
		moneyString = moneyString.."0";
	end
	moneyString = moneyString..s.."s";
	if ( c < 10 and s > 0 ) then
		moneyString = moneyString.."0";
	end
	moneyString = moneyString..c.."c";
	return moneyString;
end


function Ahplus_InboxFrame_Update()

	TheOriginal_InboxFrame_Update();
	local numItems = GetInboxNumItems();
	local index = ((InboxFrame.pageNum - 1) * INBOXITEMS_TO_DISPLAY) + 1;
	local packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead;
	local gotOne = 0;
	for i = numItems, 0, -1 do
		if ( gotOne == 0 ) then
			packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead = GetInboxHeaderInfo(i);
			if ( subject ) then
				--AhplusChatFrame:AddMessage(i .. " " .. subject);
				if ( AhplusTakeBidsFromMail == 1 and strfind(sender, "Auction House" ) ) then
					if ( strsub(subject, 1, 6) == "Outbid" or strsub(strlower(subject), 1, 9) == "Auction c" ) then
						gotOne = 1;
						if ( money > 0 ) then
							Ahplus_Print(subject ..  ":  " .. Ahplus_MoneyPrint(money));			
							TakeInboxMoney(i );
						else
							--DeleteInboxItem(i );
						end
					end
				end	
				if ( AhplusTakeItemsFromMail == 1 and strsub(sender, 11) == "Auction House" ) then
					if ( strsub(subject, 1, 11) == "Auction won" ) then
						gotOne = 1;
						if ( hasItem ) then
							TakeInboxItem(i );
							Ahplus_Print(subject);	
						else
							--DeleteInboxItem(i );
						end
					end
				end
			end
		end
	end
	if ( gotOne == 0 ) then
		AhplusTextBigMessage:Hide();
	end
end

function Ahplus_InboxFrame_OnClick(index)
	if ( this:GetChecked() ) then
		-- Setup mail item
		packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead = GetInboxHeaderInfo(index);
		if( strfind(sender, "Auction House" )) then
			if ( not hasItem ) then
				-- Money, either:  "Auction Successful" or "Outbid"
				TakeInboxMoney(index);
				DeleteInboxItem(index);
			else
				-- Item, either:  "Auction Won" or "Auction Expired"
				TakeInboxItem(index);
				DeleteInboxItem(index);
			end
		else			
			InboxFrame.openMailID = index;
			OpenMail_Update();
			ShowUIPanel(OpenMailFrame);
			PlaySound("igSpellBookOpen");
		end
	else
		InboxFrame.openMailID = 0;
		HideUIPanel(OpenMailFrame);		
	end
	InboxFrame_Update();
end


function Ahplus_OnEvent()
	if ( event == "BAG_UPDATE" ) then
		if ( AhplusSellAll ) then
			if ( not GetContainerItemLink(AhplusSellAll["bag"], AhplusSellAll["slot"]) ) then
				Ahplus_SellAllLoop();
			end
		end
	end

	if ( event == "AUCTION_HOUSE_SHOW" ) then
		ShowUIPanel(this);
		if ( AhplusTextItemName:GetText() ) then
			BrowseName:SetText( AhplusTextItemName:GetText() );
			Ahplus_QueryBegins();
			AuctionFrameBrowse_Search();
		end
	end

	if ( event == "AUCTION_HOUSE_CLOSED" ) then
		HideUIPanel(this);
		-- Turn off any outomatic stuff that may be going on.
		Ahplus_QueryEnds();
		AhplusBidOnPage = 0;
		AhplusSellAll = nil;
		AhplusAuctionNow = nil;
		AhplusBidOnPage = nil;
		AhplusBidOnSight = 0;
		AhplusBuyoutOnSight = 0;
		AhplusTextBigMessage:Hide();
	end


	if ( event == "MAIL_SHOW" ) then
		ShowUIPanel(this);
	end
	if ( event == "MAIL_CLOSED" ) then
		HideUIPanel(this);
	end
	if ( event == "CHAT_MSG_SYSTEM" ) then
		if ( strsub(arg1, 1, 20) == "You have been outbid" ) then
			Ahplus_CounterBid()
		end
	end
end

function Ahplus_CounterBid()
end
--[[	DEFAULT_CHAT_FRAME:AddMessage("Outbid!!");
	numBatchAuctions, totalAuctions = GetNumAuctionItems("bidder");
	numPages = ceil( totalAuctions / 50 );
	for j = 1, numPages do
		GetBidderAuctionItems(j);
		for i=1, numBatchAuctions do
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("bidder", i);	
			if ( i + ( j - 1 ) * 50 <= totalAuctions ) then
				DEFAULT_CHAT_FRAME:AddMessage("bid:  " .. j .. " " .. i .. " " .. name);
				if ( not highBidder ) then
					if ( AhplusCounterBid == 1 and PriceDatabase_GetPrice(name) ) then
						DEFAULT_CHAT_FRAME:AddMessage("Outbid on " .. count .. " " .. name .. " " .. AhplusMoneyPrint(bidAmount));
						if ( bidAmount + minIncrement < PriceDatabase_GetPrice(name) * count * AhplusBuyoutFactor ) then
							PlaceAuctionBid("bidder", i, bidAmount + minIncrement);
							DEFAULT_CHAT_FRAME:AddMessage("Bidding "..bidAmount + minIncrement.." on "..count.." "..name);							
						end
					end
				end
			end
		end
	end
end ]]--

function Ahplus_SellAll(msg)
	AhplusSellAll = {};
	AhplusSellAll["active"] = 1;
	AhplusSellAll["bag"] = 0;
	AhplusSellAll["slot"] = 1;
	AhplusSellAll["name"] = Ahplus_GetNameFromLink(msg);
	--AhplusChatFrame:AddMessage(msg .. " --> " .. AhplusSellAll["name"]);
	AhplusSellAll["AuctionNow"] = AhplusAuctionNow;
	AhplusAuctionNow = 1;
	Ahplus_SellingBegins();
	Ahplus_SellAllLoop();
end

function Ahplus_SellAllLoop()
	local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo();
--	DEFAULT_CHAT_FRAME:AddMessage("SellAllLoop");

	-- if something is in the sell item slot already, sell it now.
	-- that usually happens when I put something in the sell item slot, then flip back to auctions tab, set a price, and hit "sell all"
	if ( name ) then
--		DEFAULT_CHAT_FRAME:AddMessage("-=[" .. name .. "]=-");
		Ahplus_AuctionSellItemButton_OnEvent();
		Ahplus_SellAllLoop();
		return;
	end		
	local bag, slot, link;
	-- per bag
	for bag = AhplusSellAll["bag"], 4 do
		slotMax = GetContainerNumSlots(bag);
		-- per slot
		for slot = AhplusSellAll["slot"], slotMax do
			link = GetContainerItemLink(bag, slot);
			if ( link ) then
				link = Ahplus_GetNameFromLink(link);
				if( link and strlower ( link ) == strlower( AhplusSellAll["name"] ) ) then
					local temp, itemCount;
					temp, itemCount, temp, temp, temp = GetContainerItemInfo(bag, slot)
					Ahplus_Print("Selling " .. itemCount .. "x " .. link .. " from bag " .. bag .. ", slot " .. slot );
					PickupContainerItem(bag, slot);
					ClickAuctionSellItemButton();
					AhplusSellAll["bag"] = bag;
					AhplusSellAll["slot"] = slot;
					return;
				end
			end
			
		end
		AhplusSellAll["slot"] = 1;

	end
	AhplusTextBigMessage:Hide();
	AhplusSellAll = nil;
	AhplusAuctionNow = nil;
end	

function Ahplus_BidOnPage()
	AhplusBidOnPage = 1;
	AhplusBidOnSight = 1;
	AhplusBuyoutOnSight = 1;
	--AhplusChatFrame:AddMessage("Bid on sight enabled.");
	Ahplus_BiddingBegins();
	Ahplus_AuctionFrameBrowse_Update();
end

function Ahplus_NextInvItem()
	if ( AhplusNextInvItem == nil ) then
		AhplusNextInvItem = Ahplus_GetNextItem( AhplusNextInvItem );
	end

-- Only if inventory is empty
	if ( AhplusNextInvItem == nil ) then
		AhplusNextInvItem = "no item";
	end
	BrowseName:SetText(AhplusNextInvItem);
	AhplusNextInvItem = Ahplus_GetNextItem( AhplusNextInvItem );
	Ahplus_QueryBegins();
	AuctionFrameBrowse_Search();
end

function Ahplus_NextItem()
	if ( AhplusNextItem == nil ) then
		AhplusNextItem = PriceDatabase_GetNextItem( AhplusNextItem );
	end
	if ( AhplusNextItem == nil ) then
		AhplusNextItem = "no item";
	end
	AhplusCurrentItem = AhplusNextItem;
	AhplusNextItem = PriceDatabase_GetNextItem( AhplusNextItem );
	BrowseName:SetText(AhplusCurrentItem);
	Ahplus_QueryBegins();
	AuctionFrameBrowse_Search();
end

function Ahplus_UpdateMiniFrame( itemName )
	local count;
	if ( itemName) then
		count = Ahplus_GetItemCount( itemName );
	else
		count = 0;
	end
	AhplusTextInStock:SetText( "You Have:     " .. count );

	AhplusTextItemName:SetText( itemName );

	if ( PriceDatabase_GetPrice(itemName) ) then
		Ahplus_SetDisplayPrice(PriceDatabase_GetPrice(itemName) );

		if ( count > 0 ) then
			MoneyFrame_Update( "AhplusMoneyInventoryPrice", PriceDatabase_GetPrice(itemName) * count );
			AhplusSellButton:Enable();
		else
			MoneyFrame_Update( "AhplusMoneyInventoryPrice", 0);
			AhplusSellButton:Disable();
		end
	else
		Ahplus_SetDisplayPrice(0 );
		MoneyFrame_Update( "AhplusMoneyInventoryPrice", 0);
	end	


	if ( count == 0 ) then
		AhplusSellButton:Disable();
	end

	MoneyFrame_Update( "AhplusMoneyCheapItems", 0 );
	MoneyFrame_Update( "AhplusMoneyResalePrice", 0 );


end

function Ahplus_UpdatePrice()
	if ( not AhplusSuppressPDBChange ) then
		local itemname = AhplusTextItemName:GetText();
		--AhplusChatFrame:AddMessage("Updated price!!");
		if ( itemname and itemname ~= "no item" ) then
			PriceDatabase_Add(itemname, MoneyInputFrame_GetCopper(AhplusMoneyDisplayPrice) );
			Ahplus_UpdateMiniFrame( itemname );
			Ahplus_AnalyzePage();
			Ahplus_AuctionFrameBrowse_Update();
		end
	else
		AhplusSuppressPDBChange = nil;
	end
end

function Ahplus_ClearAnalysis()
	AhplusTextNumAuctions:SetText("0 Pieces.  0 Auctions.");
	MoneyFrame_Update( "AhplusMoneyResalePrice",  0 );
	MoneyFrame_Update( "AhplusMoneyCheapItems", 0);
	MoneyFrame_Update( "AhplusMoneyAvgBuyout", 0 );
	MoneyFrame_Update( "AhplusMoneyLowBuyout", 0 );
	MoneyFrame_Update( "AhplusMoneyAvgPrice", 0 );
	MoneyFrame_Update( "AhplusMoneyHighBid", 0 );
end

function Ahplus_QueryEnds()
	if ( AhplusQueryInProgress and not AhplusSellAll and not AhplusBidOnPage ) then
		AhplusQueryInProgress = nil;
		AhplusNextButton:Enable();
		AhplusNextInvButton:Enable();
		AhplusSellButton:Enable();
		AhplusBidButton:Enable();
		Ahplus_AnalyzePage();
	end
end

function Ahplus_QueryBegins()
	AhplusQueryInProgress = 1;
	AhplusNextButton:Disable();
	AhplusNextInvButton:Disable();
	AhplusSellButton:Disable();
	AhplusBidButton:Disable();
	Ahplus_ClearAnalysis();
	Ahplus_UpdateMiniFrame( BrowseName:GetText() );
	--AhplusChatFrame:AddMessage("You hit Search!");
end

function Ahplus_BiddingBegins()
	AhplusQueryInProgress = 1;
	AhplusNextButton:Disable();
	AhplusNextInvButton:Disable();
	AhplusSellButton:Disable();
	AhplusBidButton:Disable();
	Ahplus_UpdateMiniFrame( BrowseName:GetText() );
	--AhplusChatFrame:AddMessage("Bidding on " .. BrowseName:GetText() );
end

function Ahplus_SellingBegins()
	AhplusQueryInProgress = 1;
	AhplusNextButton:Disable();
	AhplusNextInvButton:Disable();
	AhplusSellButton:Disable();
	AhplusBidButton:Disable();
end


function Ahplus_SetDisplayPrice(amount)
	AhplusSuppressPDBChange = 1;
	MoneyInputFrame_SetCopper( AhplusMoneyDisplayPrice, amount);
end

function Ahplus_Print(msg)
	AhplusTextBigMessage:Show();
	AhplusTextBigMessage:SetText(msg);
end

-- These functions taken from Vendor, which isn't nearly ready yet, and has fewer potential users.

function Ahplus_GetNextItem( prevItem )
	Ahplus_TakeInventory();
	if ( prevItem ) then
		if ( AhplusInventory[strlower( prevItem ) ] ) then
			if ( next( AhplusInventory, strlower( prevItem ) ) ) then
				return next( AhplusInventory, strlower( prevItem ) );
			end
		end
	end
		return next( AhplusInventory, nil );
end

--find out how many of a certain item are in the inventory
function Ahplus_GetItemCount(itemName)

	if ( not itemName ) then
		return 0;
	end
--	DEFAULT_CHAT_FRAME:AddMessage("Ahplus_GetItemCount(" .. itemName .. ")");

	local vBag, vSlot, vSlotMax, vLink, vItem;
	local count = 0;

	-- per bag
	for vBag = 0, 4 do
		vSlotMax = GetContainerNumSlots(vBag);

		-- per slot
		for vSlot = 1, vSlotMax do
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(vBag, vSlot);
			vLink = GetContainerItemLink(vBag, vSlot);
			if ( vLink ) then
				vLink = Ahplus_GetNameFromLink(vLink);
				if ( vLink and strlower( vLink ) == strlower( itemName ) ) then
--					DEFAULT_CHAT_FRAME:AddMessage("Found " .. itemCount .. "x " .. itemName .. " in Bag " .. vBag .. " Slot " .. vSlot);
					count = count + itemCount;
				end
			end
		end
	end
	return count;
end


function Ahplus_GetNameFromLink(link)
	local begin, ending = strfind(link, "%b[]");
	if ( begin and ending ) then
		local name = strsub( link, begin + 1, ending - 1);
		return name;
	else
		return link;
	end
end

function Ahplus_TakeInventory()
	local vBag, vSlot, vSlotMax, vLink, vItem;
	AhplusInventory = {};
	
	-- per bag
	for vBag = 0, 4 do
		vSlotMax = GetContainerNumSlots(vBag);
-- DEFAULT_CHAT_FRAME:AddMessage("Bag " .. vBag .. " has " .. vSlotMax .. " slots.");

		-- per slot
		for vSlot = 1, vSlotMax do
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(vBag, vSlot);
			vLink = GetContainerItemLink(vBag, vSlot);
			if ( vLink ) then
				vLink = Ahplus_GetNameFromLink(vLink);
-- DEFAULT_CHAT_FRAME:AddMessage("Bag " .. vBag .. " Slot " .. vSlot .. " " .. itemCount .. "x" .. vLink);
				if ( PriceDatabase_GetPrice( vLink ) ) then
					if ( AhplusInventory[strlower(vLink)] ) then
						AhplusInventory[strlower(vLink)] = AhplusInventory[strlower(vLink)] + itemCount;
					else
						AhplusInventory[strlower(vLink)] = itemCount;
					end
				end
			else
--DEFAULT_CHAT_FRAME:AddMessage("Bag " .. vBag .. " Slot " .. vSlot .. " Empty");
			end
		end
	end

end

function Ahplus_ToggleOptions(msg)
	if (msg == "on" ) then
		Ahplus_options:Show();

-- Set check buttons
		if ( AhplusBidOnClick ) then
			AhplusCheckButtonBidOnClick:SetChecked(1);
		else

			AhplusCheckButtonBidOnClick:SetChecked(0);
		end

		if ( AhplusBuyoutOnClick ) then
			AhplusCheckButtonBuyoutOnClick:SetChecked(1);
		else

			AhplusCheckButtonBuyoutOnClick:SetChecked(0);
		end

		if ( AhplusTakeBidsFromMail ) then
			AhplusCheckButtonTakeBids:SetChecked(1);
		else

			AhplusCheckButtonTakeBids:SetChecked(0);
		end

		if ( AhplusTakeItemsFromMail ) then
			AhplusCheckButtonTakeItems:SetChecked(1);
		else

			AhplusCheckButtonTakeItems:SetChecked(0);
		end

		if ( AhplusShowPricePerItem ) then
			AhplusCheckButtonPricePerItem:SetChecked(1);
		else

			AhplusCheckButtonPricePerItem:SetChecked(0);
		end

-- set sliders
	AhplusSliderInitialBid:SetMinMaxValues(0.05, 1);
	AhplusSliderInitialBid:SetValueStep(0.05);
	AhplusSliderInitialBidText:SetText("Initial Bid Price Multiplier:");
	AhplusSliderInitialBidLow:SetText("5%");
	AhplusSliderInitialBidHigh:SetText("100%");

	AhplusSliderAutoBidLimit:SetMinMaxValues(0.00, 1);
	AhplusSliderAutoBidLimit:SetValueStep(0.05);
	AhplusSliderAutoBidLimitText:SetText("Automatic Bid Limit:");
	AhplusSliderAutoBidLimitLow:SetText("Free");
	AhplusSliderAutoBidLimitHigh:SetText("Your Price");

		AhplusSliderInitialBid:SetValue(AhplusInitialBidMultiplier);
		AhplusSliderAutoBidLimit:SetValue(AhplusBuyoutFactor );
	end
	if (msg == "off" ) then
		Ahplus_options:Hide();
	end

end

function Ahplus_TabSpecificText(msg)
	if (msg == 1) then
		AhplusTextAvgBuyout:SetText("Avg Buyout:");
		AhplusTextLowBuyout:SetText("Lowest Buyout:");
		AhplusTextAvgPrice:SetText("Avg Price:");
		AhplusTextHighBid:SetText("Highest Bid:");
	end
	if (msg == 2) then
		AhplusTextAvgBuyout:SetText("");
		AhplusTextLowBuyout:SetText("Amount Invested:");
		AhplusTextAvgPrice:SetText("Resale Value:");
		AhplusTextHighBid:SetText("Profit Ratio:");
	end
	if (msg == 3) then
		AhplusTextAvgBuyout:SetText("");
		AhplusTextLowBuyout:SetText("Guaranteed:");
		AhplusTextAvgPrice:SetText("Min Bids:");
		AhplusTextHighBid:SetText("Buyouts:");
	end
end

function Ahplus_SetAuctionPrice()
	local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo();
	if ( PriceDatabase_GetPrice(name) ) then
		MoneyInputFrame_SetCopper(StartPrice, max(floor(price * 1.5), floor(PriceDatabase_GetPrice(name) * count * AhplusInitialBidMultiplier )));
		UpdateDeposit();
		MoneyInputFrame_SetCopper(BuyoutPrice, max(floor(price * 1.575), floor(PriceDatabase_GetPrice(name) * count )));
	else
		MoneyInputFrame_SetCopper(StartPrice, floor(price * 1.5));
		UpdateDeposit();
		MoneyInputFrame_SetCopper(BuyoutPrice, floor(price * 1.5 / AhplusInitialBidMultiplier ));
	end
end