-- This records a bunch of prices for various goods.
-- Used in conjuction with a super-AH to make bidding on items at a good price easy
-- By SvK  http://svk.mondrary.com svk105@msn.com

function PriceDatabase_OnLoad()
	RegisterForSave("PriceDB");

	PriceDBRealm = GetCVar("realmName");
	if( PriceDB == nil ) then
		DEFAULT_CHAT_FRAME:AddMessage("Creating PriceDB");
		PriceDB = {};
	end
	PRICEDATABASE_LOADED = 1;

	-- slash commands
	SlashCmdList["PRICEDATABASESLASH"] = function(msg)
		PriceDatabase_Slash(msg);
	end;
	SLASH_PRICEDATABASESLASH1 = "/pdb";
end

function PriceDatabase_OnEvent(event)
end

function PriceDatabase_OnShow()
end

function PriceDatabase_OnHide()
end

function PriceDatabase_GetPrice(name)
	if ( PriceDB[PriceDBRealm] == nil ) then
		PriceDB[PriceDBRealm] = {};
		DEFAULT_CHAT_FRAME:AddMessage("Creating PriceDB[" .. PriceDBRealm.."]");
	end
	if ( name ) then
		if ( PriceDB[PriceDBRealm][strlower(name)] ) then
			return PriceDB[PriceDBRealm][strlower(name)];
		else
			return nil;
		end
	end
end

function PriceDatabase_Add(name, price)
	if ( PriceDB[PriceDBRealm] == nil ) then
		PriceDB[PriceDBRealm] = {};
		DEFAULT_CHAT_FRAME:AddMessage("Creating PriceDB[" .. PriceDBRealm.."]");
	end
	if ( name ) then
		PriceDB[PriceDBRealm][strlower(name)] = price;
	end

-- setting price to zero removes item from DB
	if ( price == 0 ) then
		PriceDB[PriceDBRealm][strlower(name)] = nil;
	end
end

function PriceDatabaseButton_OnLoad()
end

function PriceDatabaseButton_OnEvent(event)
end

function PriceDatabaseButton_OnClick(arg1)
end

function PriceDatabaseButton_OnEnter()
end

function PriceDatabaseButton_OnUpdate()
end

function PriceDatabase_Slash(msg)
	local temp1, itemName, i, price;
	local begin, ending;

-- print the string (temporary programming aid)
--	StringSpacer(msg);
		
--Help message
	if ( msg == "" or strlower(msg) == "help" or not msg ) then
		DEFAULT_CHAT_FRAME:AddMessage("Price Database Help:");
		DEFAULT_CHAT_FRAME:AddMessage("PriceDB keeps a list of prices for goods that you want to trade.");
		DEFAULT_CHAT_FRAME:AddMessage("Unlike other databases, it only holds the items you are interested in.");
		DEFAULT_CHAT_FRAME:AddMessage("Check a price:  /pdb Item Name");
		DEFAULT_CHAT_FRAME:AddMessage("Set a price:  /pdb Item Name nnn <--price in copper.");
		DEFAULT_CHAT_FRAME:AddMessage("Remove an item from PriceDB:  /pdb remove Item name");
		DEFAULT_CHAT_FRAME:AddMessage("Add a library:  /pdb add Libname");
		DEFAULT_CHAT_FRAME:AddMessage("Libname = cloth, leather, hides, cured hides, metal, ore, stone, gems, herbs, shards, essences, dust");
 		return;
	end
-- Cut out the item's name
	begin, ending = strfind(msg, "%b[]")
	if (begin and ending ) then
		itemName = strsub(msg, begin + 1, ending - 1);
--		DEFAULT_CHAT_FRAME:AddMessage("item: " .. itemName);
	end

-- Is this an "add" message?
	if ( strlower( strsub( msg, 1, 3 ) ) == "add" ) then
		-- remove "add" from the beginning
		msg = strsub(msg, 4);
		-- Remove leading spaces
		begin, ending = strfind(msg, "^%s+");
		if ( ending ) then
			msg = strsub(msg, ending + 1 );
		end
		DEFAULT_CHAT_FRAME:AddMessage( "--" .. msg .. "--");
		PriceDatabase_AddCategory(msg);
		return;
	end

-- Is this a "remove" message?
	if ( strlower( strsub( msg, 1, 6 ) ) == "remove" ) then
		-- remove with link
		if ( itemName ) then
			PriceDatabase_Add( itemName, nil );
			DEFAULT_CHAT_FRAME:AddMessage( "--" .. itemName .. "-- removed from PriceDB.");

		-- remove without link
		else
			msg = strsub(msg, 7);
		
			-- Remove leading spaces
			begin, ending = strfind(msg, "^%s+");
			if ( ending ) then
				msg = strsub(msg, ending + 1 );
			end
			PriceDatabase_Add( msg, nil );
			DEFAULT_CHAT_FRAME:AddMessage( "--" .. msg .. "-- removed from PriceDB.");
		end
	else

-- Look for price after item name
-- If there's a price, set that item to that price
-- If there's no price, print current price
		begin, ending = strfind(msg, "|h|r");
		if ( ending and ending < strlen(msg) ) then
			price = tonumber( strsub( msg, ending + 1 ) );
		end
		if ( price ) then
			PriceDatabase_Add(itemName, price);
			DEFAULT_CHAT_FRAME:AddMessage("New price for " .. itemName .. ":  " .. PriceDatabase_MoneyPrint(price) );
		else
			price = PriceDatabase_GetPrice( itemName );
			if ( price ) then
				DEFAULT_CHAT_FRAME:AddMessage("Current price for " .. itemName .. ":  " .. PriceDatabase_MoneyPrint( price ) );
			else
				DEFAULT_CHAT_FRAME:AddMessage(itemName .. " not in PriceDB." );
			end
		end
	end
end

-- takes a string that contains the character chr.
-- returns str1, everything in str before the first appearance of chr
-- returns str2, everything in str after the first appearance of chr
-- the first appearance of chr is not in either string
function PriceDatabase_Split(str, chr)
	local splitpoint = strfind(str, chr);
	if ( splitpoint ) then
		local str1 = strsub(str, 1, splitpoint - 1);
		local str2 = strsub(str, splitpoint + 1);
		return str1, str2;
	else
		return str, "";
	end
end

function PriceDatabase_MoneyPrint(amount)
	local c,s,g; 
	local moneyString = "";
	c = mod(amount, COPPER_PER_SILVER);
	amount = amount - c;
	amount = amount / COPPER_PER_SILVER;
	s = mod(amount, SILVER_PER_GOLD);
	amount = amount - s;
	amount = amount / SILVER_PER_GOLD;
	g = amount;

-- Round to nearest copper
	c = floor(c + 0.5);

	if ( g > 0 ) then
		moneyString = moneyString..g.."g";
	end
	if ( s < 10 and g > 0 ) then
		moneyString = moneyString.."0";
	end
	moneyString = moneyString..s.."s";
	if ( c < 10 and s > 0 ) then
		moneyString = moneyString.."0";
	end
	moneyString = moneyString..c.."c";
	return moneyString;
end

function StringSpacer(msg)
	local temp1 = "";
	for i = 1, strlen(msg) do
		temp1 = temp1 .. strsub(msg, i, i) .. ".";
	end
	DEFAULT_CHAT_FRAME:AddMessage(msg .. "=" .. temp1);
end

function PriceDatabase_GetNextItem( prevItem )
	if ( PriceDB[PriceDBRealm] == nil ) then
		PriceDB[PriceDBRealm] = {};
		DEFAULT_CHAT_FRAME:AddMessage("Creating PriceDB[" .. PriceDBRealm.."]");
	end
	if ( prevItem ) then
		if ( PriceDB[PriceDBRealm][strlower( prevItem ) ] ) then
			if ( next( PriceDB[PriceDBRealm], strlower( prevItem ) ) ) then 
				return next( PriceDB[PriceDBRealm], strlower( prevItem ) );
			end
		end
	end
	return next( PriceDB[PriceDBRealm], nil );
end

function PriceDatabase_AddCategory(msg)
	local PriceDBTempArray = {};
	if ( strlower ( msg ) == "cloth" ) then
		PriceDBTempArray = { "Linen Cloth", "Wool Cloth", "Silk Cloth", "Mageweave Cloth", "Runecloth", "Felcloth", "Mooncloth" };
	end

	if ( strlower ( msg ) == "metal" ) then
		PriceDBTempArray = { "Copper Bar", "Tin Bar", "Bronze Bar", "Iron Bar", "Steel Bar", "Mithril Bar", "Thorium Bar", "Silver Bar", "Truesilver Bar", "Gold Bar", "Arcanite Bar" };
	end

	if ( strlower ( msg ) == "leather" ) then
		PriceDBTempArray = { "Light Leather", "Medium Leather", "Heavy Leather", "Thick Leather", "Rugged Leather", "Enchanted Leather" };
	end

	if ( strlower ( msg ) == "stone" ) then
		PriceDBTempArray = { "Rough Stone", "Coarse Stone", "Solid Stone", "Heavy Stone", "Dense Stone" };
	end

	if ( strlower ( msg ) == "hides" ) then
		PriceDBTempArray = {"Light Hide", "Medium Hide", "Heavy Hide", "Thick Hide", "Rugged Hide", "Cured Light Hide", "Cured Medium Hide", "Cured Heavy Hide", "Cured Thick Hide", "Cured Rugged Hide"};
	end

	if ( strlower ( msg ) == "gems" ) then
		PriceDBTempArray = { "Malachite", "Shadowgem", "Tigerseye", "Jade", "Citrine", "Lesser Moonstone", "Moss Agate", "Aquamarine", "Blue Sapphire", "Large Opal", "Star Ruby", "Arcane Crystal", "Azerothian Diamond", "Huge Emerald", "Black Vitriol" };
	end

	if ( strlower ( msg ) == "herbs" ) then
		PriceDBTempArray = { "Peacebloom", "Silverleaf", "Swiftthistle", "Mageroyal", "Earthroot", "Briarthorn", "Grave Moss", "Kingsblood", "Wild Steebloom", "Liferoot", "Stranglekelp", "Bruiseweed", "Fadeleaf", "Goldthorn", "Khadgar's Whisker", "Wintersbite", "Purple Lotus", "Firebloom", "Sungrass", "Wildvine", "Arthas' Tears", "Blindweed", "Ghost Mushroom", "Gromsblood", "Dreamfoil", "Plaguebloom", "Golden Sansam", "Mountain Silversage", "Icecap" };
	end

	if ( strlower ( msg ) == "ore" ) then
		PriceDBTempArray = { "Copper Ore", "Tin Ore", "Iron Ore", "Mithril Ore", "Thorium Ore", "Silver Ore", "Gold Ore", "Truesilver Ore" };
	end

	if ( strlower ( msg ) == "shards" ) then
		PriceDBTempArray = { "Large Brilliant Shard", "Large Glimmering Shard", "Large Glowing Shard", "Large Radiant Shard", "Small Brilliant Shard", "Small Glimmering Shard", "Small Glowing Shard", "Small Radiant Shard" };
	end

	if ( strlower ( msg ) == "essences" ) then
		PriceDBTempArray = { "Greater Astral Essence", "Greater Eternal Essence", "Greater Magic Essence", "Greater Mystic Essence", "Greater Nether Essence", "Lesser Astral Essence", "Lesser Eternal Essence", "Lesser Magic Essence", "Lesser Mystic Essence", "Lesser Nether Essence" };
	end

	if ( strlower ( msg ) == "dust" ) then
		PriceDBTempArray = { "Dream Dust", "Illusion Dust", "Soul Dust", "Vision Dust", "Strange Dust" };
	end

	if ( strlower ( msg ) == "all" ) then
		PriceDatabase_AddCategory("cloth");
		PriceDatabase_AddCategory("metal");
		PriceDatabase_AddCategory("leather");
		PriceDatabase_AddCategory("stone");
		PriceDatabase_AddCategory("hides");
		PriceDatabase_AddCategory("gems");
		PriceDatabase_AddCategory("herbs");
		PriceDatabase_AddCategory("ore");
		PriceDatabase_AddCategory("shards");
		PriceDatabase_AddCategory("essences");
		PriceDatabase_AddCategory("dust");
	end

--	if ( strlower ( msg ) == "" ) then
--		PriceDBTempArray = {  };
--	end

	for index, value in PriceDBTempArray do
		if ( not PriceDatabase_GetPrice( value ) ) then
			DEFAULT_CHAT_FRAME:AddMessage("Adding " .. value );
			PriceDatabase_Add(value, 1);
		else
			DEFAULT_CHAT_FRAME:AddMessage(value .. " already defined.");
		end
	end
end